#include <openvr.h>
#include "openvrcamera.h"
#include "openvrsystem.h"

namespace Msp {
namespace VR {

OpenVRCamera::OpenVRCamera(const OpenVRSystem &d, const GL::Camera &c):
	HeadTrackingCamera(c),
	system(d)
{ }

void OpenVRCamera::reset_tracking()
{
	vr::VRSystem()->ResetSeatedZeroPose();
}

void OpenVRCamera::update()
{
	update_from_matrix(system.get_hmd_matrix());
}

} // namespace VR
} // namespace Msp
