#ifndef MSP_VR_OPENVRCOMBINER_H_
#define MSP_VR_OPENVRCOMBINER_H_

#include <msp/gl/view.h>
#include <msp/vr/stereocombiner.h>

namespace Msp {
namespace VR {

class OpenVRSystem;

class OpenVRCombiner: public StereoCombiner
{
private:
	struct Private;

	OpenVRSystem &system;
	GL::View &view;

public:
	OpenVRCombiner(OpenVRSystem &, GL::View &);

	virtual bool is_mirroring_supported() const { return true; }
	virtual void prepare() const;
	virtual void render(const GL::Texture2D &, const GL::Texture2D &) const;
};

} // namespace VR
} // namespace Msp

#endif
